# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetFloatingIpsV2Result',
    'AwaitableGetFloatingIpsV2Result',
    'get_floating_ips_v2',
    'get_floating_ips_v2_output',
]

@pulumi.output_type
class GetFloatingIpsV2Result:
    """
    A collection of values returned by getFloatingIpsV2.
    """
    def __init__(__self__, expand=None, filter=None, floating_ips=None, id=None, limit=None, order_by=None, page=None):
        if expand and not isinstance(expand, str):
            raise TypeError("Expected argument 'expand' to be a str")
        pulumi.set(__self__, "expand", expand)
        if filter and not isinstance(filter, str):
            raise TypeError("Expected argument 'filter' to be a str")
        pulumi.set(__self__, "filter", filter)
        if floating_ips and not isinstance(floating_ips, list):
            raise TypeError("Expected argument 'floating_ips' to be a list")
        pulumi.set(__self__, "floating_ips", floating_ips)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if order_by and not isinstance(order_by, str):
            raise TypeError("Expected argument 'order_by' to be a str")
        pulumi.set(__self__, "order_by", order_by)
        if page and not isinstance(page, int):
            raise TypeError("Expected argument 'page' to be a int")
        pulumi.set(__self__, "page", page)

    @property
    @pulumi.getter
    def expand(self) -> Optional[str]:
        return pulumi.get(self, "expand")

    @property
    @pulumi.getter
    def filter(self) -> Optional[str]:
        return pulumi.get(self, "filter")

    @property
    @pulumi.getter(name="floatingIps")
    def floating_ips(self) -> Sequence['outputs.GetFloatingIpsV2FloatingIpResult']:
        return pulumi.get(self, "floating_ips")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter(name="orderBy")
    def order_by(self) -> Optional[str]:
        return pulumi.get(self, "order_by")

    @property
    @pulumi.getter
    def page(self) -> Optional[int]:
        return pulumi.get(self, "page")


class AwaitableGetFloatingIpsV2Result(GetFloatingIpsV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFloatingIpsV2Result(
            expand=self.expand,
            filter=self.filter,
            floating_ips=self.floating_ips,
            id=self.id,
            limit=self.limit,
            order_by=self.order_by,
            page=self.page)


def get_floating_ips_v2(expand: Optional[str] = None,
                        filter: Optional[str] = None,
                        limit: Optional[int] = None,
                        order_by: Optional[str] = None,
                        page: Optional[int] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFloatingIpsV2Result:
    """
    Provides a datasource to retrieve floating IP with floating_ip_uuid .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    floating_ips = nutanix.get_floating_ips_v2()
    ```


    :param str expand: A URL query parameter that allows clients to request related resources when a resource that satisfies a particular request is retrieved.
    :param str filter: A URL query parameter that allows clients to filter a collection of resources.
    :param int limit: A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    :param str order_by: A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default
    :param int page: A URL query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource. Any number out of this range might lead to no results.
    """
    __args__ = dict()
    __args__['expand'] = expand
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderBy'] = order_by
    __args__['page'] = page
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getFloatingIpsV2:getFloatingIpsV2', __args__, opts=opts, typ=GetFloatingIpsV2Result).value

    return AwaitableGetFloatingIpsV2Result(
        expand=pulumi.get(__ret__, 'expand'),
        filter=pulumi.get(__ret__, 'filter'),
        floating_ips=pulumi.get(__ret__, 'floating_ips'),
        id=pulumi.get(__ret__, 'id'),
        limit=pulumi.get(__ret__, 'limit'),
        order_by=pulumi.get(__ret__, 'order_by'),
        page=pulumi.get(__ret__, 'page'))
def get_floating_ips_v2_output(expand: Optional[pulumi.Input[Optional[str]]] = None,
                               filter: Optional[pulumi.Input[Optional[str]]] = None,
                               limit: Optional[pulumi.Input[Optional[int]]] = None,
                               order_by: Optional[pulumi.Input[Optional[str]]] = None,
                               page: Optional[pulumi.Input[Optional[int]]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFloatingIpsV2Result]:
    """
    Provides a datasource to retrieve floating IP with floating_ip_uuid .

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    floating_ips = nutanix.get_floating_ips_v2()
    ```


    :param str expand: A URL query parameter that allows clients to request related resources when a resource that satisfies a particular request is retrieved.
    :param str filter: A URL query parameter that allows clients to filter a collection of resources.
    :param int limit: A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    :param str order_by: A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default
    :param int page: A URL query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource. Any number out of this range might lead to no results.
    """
    __args__ = dict()
    __args__['expand'] = expand
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderBy'] = order_by
    __args__['page'] = page
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getFloatingIpsV2:getFloatingIpsV2', __args__, opts=opts, typ=GetFloatingIpsV2Result)
    return __ret__.apply(lambda __response__: GetFloatingIpsV2Result(
        expand=pulumi.get(__response__, 'expand'),
        filter=pulumi.get(__response__, 'filter'),
        floating_ips=pulumi.get(__response__, 'floating_ips'),
        id=pulumi.get(__response__, 'id'),
        limit=pulumi.get(__response__, 'limit'),
        order_by=pulumi.get(__response__, 'order_by'),
        page=pulumi.get(__response__, 'page')))
