# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetUsersV2Result',
    'AwaitableGetUsersV2Result',
    'get_users_v2',
    'get_users_v2_output',
]

@pulumi.output_type
class GetUsersV2Result:
    """
    A collection of values returned by getUsersV2.
    """
    def __init__(__self__, filter=None, id=None, limit=None, order_by=None, page=None, select=None, users=None):
        if filter and not isinstance(filter, str):
            raise TypeError("Expected argument 'filter' to be a str")
        pulumi.set(__self__, "filter", filter)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if order_by and not isinstance(order_by, str):
            raise TypeError("Expected argument 'order_by' to be a str")
        pulumi.set(__self__, "order_by", order_by)
        if page and not isinstance(page, int):
            raise TypeError("Expected argument 'page' to be a int")
        pulumi.set(__self__, "page", page)
        if select and not isinstance(select, str):
            raise TypeError("Expected argument 'select' to be a str")
        pulumi.set(__self__, "select", select)
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def filter(self) -> Optional[str]:
        return pulumi.get(self, "filter")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter(name="orderBy")
    def order_by(self) -> Optional[str]:
        return pulumi.get(self, "order_by")

    @property
    @pulumi.getter
    def page(self) -> Optional[int]:
        return pulumi.get(self, "page")

    @property
    @pulumi.getter
    def select(self) -> Optional[str]:
        return pulumi.get(self, "select")

    @property
    @pulumi.getter
    def users(self) -> Sequence['outputs.GetUsersV2UserResult']:
        """
        List all User(s).
        """
        return pulumi.get(self, "users")


class AwaitableGetUsersV2Result(GetUsersV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUsersV2Result(
            filter=self.filter,
            id=self.id,
            limit=self.limit,
            order_by=self.order_by,
            page=self.page,
            select=self.select,
            users=self.users)


def get_users_v2(filter: Optional[str] = None,
                 limit: Optional[int] = None,
                 order_by: Optional[str] = None,
                 page: Optional[int] = None,
                 select: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUsersV2Result:
    """
    Provides a datasource to retrieve all User(s).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    users = nutanix.get_users_v2()
    ```

    ## Argument Reference

    The following arguments are supported:

    * `page`: - A URL query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource. Any number out of this range might lead to no results.
    * `limit` : A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    * `filter` :A URL query parameter that allows clients to filter a collection of resources. The expression specified with \\$filter is evaluated for each resource in the collection, and only items where the expression evaluates to true are included in the response. Expression specified with the \\$filter must conform to the OData V4.01 URL conventions. For example, filter '\\$filter=name eq 'karbon-ntnx-1.0' would filter the result on cluster name 'karbon-ntnx1.0', filter '\\$filter=startswith(name, 'C')' would filter on cluster name starting with 'C'. The filter can be applied to the following fields:
        * createdBy
        * displayName
        * emailId
        * extId
        * firstName
        * idpId
        * lastName
        * lastUpdatedBy
        * status
        * userType
        * username
    * `orderby` : A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default. For example, '\\$orderby=templateName desc' would get all templates sorted by templateName in descending order. The orderby can be applied to the following fields:     * createdBy
        * createdTime
        * displayName
        * emailId
        * extId
        * firstName
        * lastLoginTime
        * lastName
        * lastUpdatedTime
        * userType
        * username
    * `select` : A URL query parameter that allows clients to request a specific set of properties for each entity or complex type. Expression specified with the \\$select must conform to the OData V4.01 URL conventions. If a \\$select expression consists of a single select item that is an asterisk (i.e., *), then all properties on the matching resource will be returned. following fields:
        * additionalAttributes
        * bucketsAccessKeys
        * createdBy
        * createdTime
        * displayName
        * emailId
        * extId
        * firstName
        * idpId
        * isForceResetPasswordEnabled
        * lastLoginTime
        * lastName
        * lastUpdatedBy
        * lastUpdatedTime
        * links
        * locale
        * middleInitial
        * region
        * status
        * tenantId
        * userType
        * username
    """
    __args__ = dict()
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderBy'] = order_by
    __args__['page'] = page
    __args__['select'] = select
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getUsersV2:getUsersV2', __args__, opts=opts, typ=GetUsersV2Result).value

    return AwaitableGetUsersV2Result(
        filter=pulumi.get(__ret__, 'filter'),
        id=pulumi.get(__ret__, 'id'),
        limit=pulumi.get(__ret__, 'limit'),
        order_by=pulumi.get(__ret__, 'order_by'),
        page=pulumi.get(__ret__, 'page'),
        select=pulumi.get(__ret__, 'select'),
        users=pulumi.get(__ret__, 'users'))
def get_users_v2_output(filter: Optional[pulumi.Input[Optional[str]]] = None,
                        limit: Optional[pulumi.Input[Optional[int]]] = None,
                        order_by: Optional[pulumi.Input[Optional[str]]] = None,
                        page: Optional[pulumi.Input[Optional[int]]] = None,
                        select: Optional[pulumi.Input[Optional[str]]] = None,
                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetUsersV2Result]:
    """
    Provides a datasource to retrieve all User(s).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    users = nutanix.get_users_v2()
    ```

    ## Argument Reference

    The following arguments are supported:

    * `page`: - A URL query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource. Any number out of this range might lead to no results.
    * `limit` : A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    * `filter` :A URL query parameter that allows clients to filter a collection of resources. The expression specified with \\$filter is evaluated for each resource in the collection, and only items where the expression evaluates to true are included in the response. Expression specified with the \\$filter must conform to the OData V4.01 URL conventions. For example, filter '\\$filter=name eq 'karbon-ntnx-1.0' would filter the result on cluster name 'karbon-ntnx1.0', filter '\\$filter=startswith(name, 'C')' would filter on cluster name starting with 'C'. The filter can be applied to the following fields:
        * createdBy
        * displayName
        * emailId
        * extId
        * firstName
        * idpId
        * lastName
        * lastUpdatedBy
        * status
        * userType
        * username
    * `orderby` : A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default. For example, '\\$orderby=templateName desc' would get all templates sorted by templateName in descending order. The orderby can be applied to the following fields:     * createdBy
        * createdTime
        * displayName
        * emailId
        * extId
        * firstName
        * lastLoginTime
        * lastName
        * lastUpdatedTime
        * userType
        * username
    * `select` : A URL query parameter that allows clients to request a specific set of properties for each entity or complex type. Expression specified with the \\$select must conform to the OData V4.01 URL conventions. If a \\$select expression consists of a single select item that is an asterisk (i.e., *), then all properties on the matching resource will be returned. following fields:
        * additionalAttributes
        * bucketsAccessKeys
        * createdBy
        * createdTime
        * displayName
        * emailId
        * extId
        * firstName
        * idpId
        * isForceResetPasswordEnabled
        * lastLoginTime
        * lastName
        * lastUpdatedBy
        * lastUpdatedTime
        * links
        * locale
        * middleInitial
        * region
        * status
        * tenantId
        * userType
        * username
    """
    __args__ = dict()
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderBy'] = order_by
    __args__['page'] = page
    __args__['select'] = select
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getUsersV2:getUsersV2', __args__, opts=opts, typ=GetUsersV2Result)
    return __ret__.apply(lambda __response__: GetUsersV2Result(
        filter=pulumi.get(__response__, 'filter'),
        id=pulumi.get(__response__, 'id'),
        limit=pulumi.get(__response__, 'limit'),
        order_by=pulumi.get(__response__, 'order_by'),
        page=pulumi.get(__response__, 'page'),
        select=pulumi.get(__response__, 'select'),
        users=pulumi.get(__response__, 'users')))
