# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetVolumeGroupDisksV2Result',
    'AwaitableGetVolumeGroupDisksV2Result',
    'get_volume_group_disks_v2',
    'get_volume_group_disks_v2_output',
]

@pulumi.output_type
class GetVolumeGroupDisksV2Result:
    """
    A collection of values returned by getVolumeGroupDisksV2.
    """
    def __init__(__self__, disks=None, filter=None, id=None, limit=None, orderby=None, page=None, select=None, volume_group_ext_id=None):
        if disks and not isinstance(disks, list):
            raise TypeError("Expected argument 'disks' to be a list")
        pulumi.set(__self__, "disks", disks)
        if filter and not isinstance(filter, str):
            raise TypeError("Expected argument 'filter' to be a str")
        pulumi.set(__self__, "filter", filter)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if orderby and not isinstance(orderby, str):
            raise TypeError("Expected argument 'orderby' to be a str")
        pulumi.set(__self__, "orderby", orderby)
        if page and not isinstance(page, int):
            raise TypeError("Expected argument 'page' to be a int")
        pulumi.set(__self__, "page", page)
        if select and not isinstance(select, str):
            raise TypeError("Expected argument 'select' to be a str")
        pulumi.set(__self__, "select", select)
        if volume_group_ext_id and not isinstance(volume_group_ext_id, str):
            raise TypeError("Expected argument 'volume_group_ext_id' to be a str")
        pulumi.set(__self__, "volume_group_ext_id", volume_group_ext_id)

    @property
    @pulumi.getter
    def disks(self) -> Sequence['outputs.GetVolumeGroupDisksV2DiskResult']:
        """
        - List of disks corresponding to a Volume Group identified by {volumeGroupExtId}.
        """
        return pulumi.get(self, "disks")

    @property
    @pulumi.getter
    def filter(self) -> Optional[str]:
        return pulumi.get(self, "filter")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def orderby(self) -> Optional[str]:
        return pulumi.get(self, "orderby")

    @property
    @pulumi.getter
    def page(self) -> Optional[int]:
        return pulumi.get(self, "page")

    @property
    @pulumi.getter
    def select(self) -> Optional[str]:
        return pulumi.get(self, "select")

    @property
    @pulumi.getter(name="volumeGroupExtId")
    def volume_group_ext_id(self) -> str:
        return pulumi.get(self, "volume_group_ext_id")


class AwaitableGetVolumeGroupDisksV2Result(GetVolumeGroupDisksV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVolumeGroupDisksV2Result(
            disks=self.disks,
            filter=self.filter,
            id=self.id,
            limit=self.limit,
            orderby=self.orderby,
            page=self.page,
            select=self.select,
            volume_group_ext_id=self.volume_group_ext_id)


def get_volume_group_disks_v2(filter: Optional[str] = None,
                              limit: Optional[int] = None,
                              orderby: Optional[str] = None,
                              page: Optional[int] = None,
                              select: Optional[str] = None,
                              volume_group_ext_id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVolumeGroupDisksV2Result:
    """
    Query the list of disks corresponding to a Volume Group identified by {volumeGroupExtId}.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    example_volume_group_v2 = nutanix.VolumeGroupV2("exampleVolumeGroupV2",
        description="Test Volume group with min spec and no Auth",
        should_load_balance_vm_attachments=False,
        sharing_status="SHARED",
        target_name="volumegroup-test-0",
        created_by="Test",
        cluster_reference="<Cluster uuid>",
        iscsi_features=[{
            "enabled_authentications": "CHAP",
            "target_secret": "1234567891011",
        }],
        storage_features=[{
            "flash_modes": [{
                "is_enabled": True,
            }],
        }],
        usage_type="USER",
        is_hidden=False)
    # Attach a volume group disk to the previous volume group
    example_volume_group_disk_v2 = nutanix.VolumeGroupDiskV2("exampleVolumeGroupDiskV2",
        volume_group_ext_id=resource["nutanix_volume_group_v2"]["example"]["id"],
        index=1,
        description="create volume disk test",
        disk_size_bytes=5368709120,
        disk_data_source_references=[{
            "name": "disk1",
            "ext_id": var["disk_data_source_ref_ext_id"],
            "entity_type": "STORAGE_CONTAINER",
            "uris": [
                "uri1",
                "uri2",
            ],
        }],
        disk_storage_features=[{
            "flash_modes": [{
                "is_enabled": False,
            }],
        }])
    example_volume_group_disks_v2 = nutanix.get_volume_group_disks_v2(volume_group_ext_id=resource["nutanix_volume_group_v2"]["example"]["id"],
        filter="startswith(storageContainerId, var.filter_value)",
        limit=1)
    ```

    ## Argument Reference

    The following arguments are supported:

    * `volume_group_ext_id`: -(Required) The external identifier of the Volume Group.
    * `page`: - A query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource.
    * `limit` : A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    * `filter` : A URL query parameter that allows clients to filter a collection of resources. The expression specified with \\$filter is evaluated for each resource in the collection, and only items where the expression evaluates to true are included in the response. Expression specified with the \\$filter must conform to the OData V4.01 URL conventions. For example, filter '\\$filter=name eq 'karbon-ntnx-1.0' would filter the result on cluster name 'karbon-ntnx1.0', filter '\\$filter=startswith(name, 'C')' would filter on cluster name starting with 'C'. The filter can be applied to the following fields: storageContainerId.
    * `orderby` : A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default. For example, '\\$orderby=templateName desc' would get all templates sorted by templateName in descending order. The orderby can be applied to the following fields: diskSizeBytes.
    * `expand` : A URL query parameter that allows clients to request related resources when a resource that satisfies a particular request is retrieved. Each expanded item is evaluated relative to the entity containing the property being expanded. Other query options can be applied to an expanded property by appending a semicolon-separated list of query options, enclosed in parentheses, to the property name. Permissible system query options are \\$filter, \\$select and \\$orderby. The following expansion keys are supported. The expand can be applied to the following fields: clusterReference, metadata.
    * `select` : A query parameter that allows clients to request a specific set of properties for each entity or complex type. Expression specified with the \\$select must conform to the OData V4.01 URL conventions. If a \\$select expression consists of a single select item that is an asterisk (i.e., \\*), then all properties on the matching resource will be returned. The select can be applied to the following fields: extId, storageContainerId.
    """
    __args__ = dict()
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderby'] = orderby
    __args__['page'] = page
    __args__['select'] = select
    __args__['volumeGroupExtId'] = volume_group_ext_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getVolumeGroupDisksV2:getVolumeGroupDisksV2', __args__, opts=opts, typ=GetVolumeGroupDisksV2Result).value

    return AwaitableGetVolumeGroupDisksV2Result(
        disks=pulumi.get(__ret__, 'disks'),
        filter=pulumi.get(__ret__, 'filter'),
        id=pulumi.get(__ret__, 'id'),
        limit=pulumi.get(__ret__, 'limit'),
        orderby=pulumi.get(__ret__, 'orderby'),
        page=pulumi.get(__ret__, 'page'),
        select=pulumi.get(__ret__, 'select'),
        volume_group_ext_id=pulumi.get(__ret__, 'volume_group_ext_id'))
def get_volume_group_disks_v2_output(filter: Optional[pulumi.Input[Optional[str]]] = None,
                                     limit: Optional[pulumi.Input[Optional[int]]] = None,
                                     orderby: Optional[pulumi.Input[Optional[str]]] = None,
                                     page: Optional[pulumi.Input[Optional[int]]] = None,
                                     select: Optional[pulumi.Input[Optional[str]]] = None,
                                     volume_group_ext_id: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVolumeGroupDisksV2Result]:
    """
    Query the list of disks corresponding to a Volume Group identified by {volumeGroupExtId}.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    example_volume_group_v2 = nutanix.VolumeGroupV2("exampleVolumeGroupV2",
        description="Test Volume group with min spec and no Auth",
        should_load_balance_vm_attachments=False,
        sharing_status="SHARED",
        target_name="volumegroup-test-0",
        created_by="Test",
        cluster_reference="<Cluster uuid>",
        iscsi_features=[{
            "enabled_authentications": "CHAP",
            "target_secret": "1234567891011",
        }],
        storage_features=[{
            "flash_modes": [{
                "is_enabled": True,
            }],
        }],
        usage_type="USER",
        is_hidden=False)
    # Attach a volume group disk to the previous volume group
    example_volume_group_disk_v2 = nutanix.VolumeGroupDiskV2("exampleVolumeGroupDiskV2",
        volume_group_ext_id=resource["nutanix_volume_group_v2"]["example"]["id"],
        index=1,
        description="create volume disk test",
        disk_size_bytes=5368709120,
        disk_data_source_references=[{
            "name": "disk1",
            "ext_id": var["disk_data_source_ref_ext_id"],
            "entity_type": "STORAGE_CONTAINER",
            "uris": [
                "uri1",
                "uri2",
            ],
        }],
        disk_storage_features=[{
            "flash_modes": [{
                "is_enabled": False,
            }],
        }])
    example_volume_group_disks_v2 = nutanix.get_volume_group_disks_v2(volume_group_ext_id=resource["nutanix_volume_group_v2"]["example"]["id"],
        filter="startswith(storageContainerId, var.filter_value)",
        limit=1)
    ```

    ## Argument Reference

    The following arguments are supported:

    * `volume_group_ext_id`: -(Required) The external identifier of the Volume Group.
    * `page`: - A query parameter that specifies the page number of the result set. It must be a positive integer between 0 and the maximum number of pages that are available for that resource.
    * `limit` : A URL query parameter that specifies the total number of records returned in the result set. Must be a positive integer between 1 and 100. Any number out of this range will lead to a validation error. If the limit is not provided, a default value of 50 records will be returned in the result set.
    * `filter` : A URL query parameter that allows clients to filter a collection of resources. The expression specified with \\$filter is evaluated for each resource in the collection, and only items where the expression evaluates to true are included in the response. Expression specified with the \\$filter must conform to the OData V4.01 URL conventions. For example, filter '\\$filter=name eq 'karbon-ntnx-1.0' would filter the result on cluster name 'karbon-ntnx1.0', filter '\\$filter=startswith(name, 'C')' would filter on cluster name starting with 'C'. The filter can be applied to the following fields: storageContainerId.
    * `orderby` : A URL query parameter that allows clients to specify the sort criteria for the returned list of objects. Resources can be sorted in ascending order using asc or descending order using desc. If asc or desc are not specified, the resources will be sorted in ascending order by default. For example, '\\$orderby=templateName desc' would get all templates sorted by templateName in descending order. The orderby can be applied to the following fields: diskSizeBytes.
    * `expand` : A URL query parameter that allows clients to request related resources when a resource that satisfies a particular request is retrieved. Each expanded item is evaluated relative to the entity containing the property being expanded. Other query options can be applied to an expanded property by appending a semicolon-separated list of query options, enclosed in parentheses, to the property name. Permissible system query options are \\$filter, \\$select and \\$orderby. The following expansion keys are supported. The expand can be applied to the following fields: clusterReference, metadata.
    * `select` : A query parameter that allows clients to request a specific set of properties for each entity or complex type. Expression specified with the \\$select must conform to the OData V4.01 URL conventions. If a \\$select expression consists of a single select item that is an asterisk (i.e., \\*), then all properties on the matching resource will be returned. The select can be applied to the following fields: extId, storageContainerId.
    """
    __args__ = dict()
    __args__['filter'] = filter
    __args__['limit'] = limit
    __args__['orderby'] = orderby
    __args__['page'] = page
    __args__['select'] = select
    __args__['volumeGroupExtId'] = volume_group_ext_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getVolumeGroupDisksV2:getVolumeGroupDisksV2', __args__, opts=opts, typ=GetVolumeGroupDisksV2Result)
    return __ret__.apply(lambda __response__: GetVolumeGroupDisksV2Result(
        disks=pulumi.get(__response__, 'disks'),
        filter=pulumi.get(__response__, 'filter'),
        id=pulumi.get(__response__, 'id'),
        limit=pulumi.get(__response__, 'limit'),
        orderby=pulumi.get(__response__, 'orderby'),
        page=pulumi.get(__response__, 'page'),
        select=pulumi.get(__response__, 'select'),
        volume_group_ext_id=pulumi.get(__response__, 'volume_group_ext_id')))
