# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NgtInsertIsoV2Args', 'NgtInsertIsoV2']

@pulumi.input_type
class NgtInsertIsoV2Args:
    def __init__(__self__, *,
                 ext_id: pulumi.Input[str],
                 capablities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 is_config_only: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a NgtInsertIsoV2 resource.
        :param pulumi.Input[str] ext_id: uuid of the Virtual Machine.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] capablities: The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        :param pulumi.Input[bool] is_config_only: Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        """
        pulumi.set(__self__, "ext_id", ext_id)
        if capablities is not None:
            pulumi.set(__self__, "capablities", capablities)
        if is_config_only is not None:
            pulumi.set(__self__, "is_config_only", is_config_only)

    @property
    @pulumi.getter(name="extId")
    def ext_id(self) -> pulumi.Input[str]:
        """
        uuid of the Virtual Machine.
        """
        return pulumi.get(self, "ext_id")

    @ext_id.setter
    def ext_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "ext_id", value)

    @property
    @pulumi.getter
    def capablities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        """
        return pulumi.get(self, "capablities")

    @capablities.setter
    def capablities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "capablities", value)

    @property
    @pulumi.getter(name="isConfigOnly")
    def is_config_only(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        """
        return pulumi.get(self, "is_config_only")

    @is_config_only.setter
    def is_config_only(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_config_only", value)


@pulumi.input_type
class _NgtInsertIsoV2State:
    def __init__(__self__, *,
                 available_version: Optional[pulumi.Input[str]] = None,
                 capablities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ext_id: Optional[pulumi.Input[str]] = None,
                 guest_os_version: Optional[pulumi.Input[str]] = None,
                 is_config_only: Optional[pulumi.Input[bool]] = None,
                 is_enabled: Optional[pulumi.Input[bool]] = None,
                 is_installed: Optional[pulumi.Input[bool]] = None,
                 is_iso_inserted: Optional[pulumi.Input[bool]] = None,
                 is_reachable: Optional[pulumi.Input[bool]] = None,
                 is_vm_mobility_drivers_installed: Optional[pulumi.Input[bool]] = None,
                 is_vss_snapshot_capable: Optional[pulumi.Input[bool]] = None,
                 version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NgtInsertIsoV2 resources.
        :param pulumi.Input[str] available_version: Version of Nutanix Guest Tools available on the cluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] capablities: The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        :param pulumi.Input[str] ext_id: uuid of the Virtual Machine.
        :param pulumi.Input[str] guest_os_version: Version of the operating system on the VM.
        :param pulumi.Input[bool] is_config_only: Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        :param pulumi.Input[bool] is_enabled: Indicates whether Nutanix Guest Tools is enabled or not.
        :param pulumi.Input[bool] is_installed: Indicates whether Nutanix Guest Tools is installed on the VM or not.
        :param pulumi.Input[bool] is_iso_inserted: Indicates whether Nutanix Guest Tools ISO is inserted or not.
        :param pulumi.Input[bool] is_reachable: Indicates whether the communication from VM to CVM is active or not.
        :param pulumi.Input[bool] is_vm_mobility_drivers_installed: Indicates whether the VM mobility drivers are installed on the VM or not.
        :param pulumi.Input[bool] is_vss_snapshot_capable: Indicates whether the VM is configured to take VSS snapshots through NGT or not.
        :param pulumi.Input[str] version: Version of Nutanix Guest Tools installed on the VM.
        """
        if available_version is not None:
            pulumi.set(__self__, "available_version", available_version)
        if capablities is not None:
            pulumi.set(__self__, "capablities", capablities)
        if ext_id is not None:
            pulumi.set(__self__, "ext_id", ext_id)
        if guest_os_version is not None:
            pulumi.set(__self__, "guest_os_version", guest_os_version)
        if is_config_only is not None:
            pulumi.set(__self__, "is_config_only", is_config_only)
        if is_enabled is not None:
            pulumi.set(__self__, "is_enabled", is_enabled)
        if is_installed is not None:
            pulumi.set(__self__, "is_installed", is_installed)
        if is_iso_inserted is not None:
            pulumi.set(__self__, "is_iso_inserted", is_iso_inserted)
        if is_reachable is not None:
            pulumi.set(__self__, "is_reachable", is_reachable)
        if is_vm_mobility_drivers_installed is not None:
            pulumi.set(__self__, "is_vm_mobility_drivers_installed", is_vm_mobility_drivers_installed)
        if is_vss_snapshot_capable is not None:
            pulumi.set(__self__, "is_vss_snapshot_capable", is_vss_snapshot_capable)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="availableVersion")
    def available_version(self) -> Optional[pulumi.Input[str]]:
        """
        Version of Nutanix Guest Tools available on the cluster.
        """
        return pulumi.get(self, "available_version")

    @available_version.setter
    def available_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "available_version", value)

    @property
    @pulumi.getter
    def capablities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        """
        return pulumi.get(self, "capablities")

    @capablities.setter
    def capablities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "capablities", value)

    @property
    @pulumi.getter(name="extId")
    def ext_id(self) -> Optional[pulumi.Input[str]]:
        """
        uuid of the Virtual Machine.
        """
        return pulumi.get(self, "ext_id")

    @ext_id.setter
    def ext_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ext_id", value)

    @property
    @pulumi.getter(name="guestOsVersion")
    def guest_os_version(self) -> Optional[pulumi.Input[str]]:
        """
        Version of the operating system on the VM.
        """
        return pulumi.get(self, "guest_os_version")

    @guest_os_version.setter
    def guest_os_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "guest_os_version", value)

    @property
    @pulumi.getter(name="isConfigOnly")
    def is_config_only(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        """
        return pulumi.get(self, "is_config_only")

    @is_config_only.setter
    def is_config_only(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_config_only", value)

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Nutanix Guest Tools is enabled or not.
        """
        return pulumi.get(self, "is_enabled")

    @is_enabled.setter
    def is_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_enabled", value)

    @property
    @pulumi.getter(name="isInstalled")
    def is_installed(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Nutanix Guest Tools is installed on the VM or not.
        """
        return pulumi.get(self, "is_installed")

    @is_installed.setter
    def is_installed(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_installed", value)

    @property
    @pulumi.getter(name="isIsoInserted")
    def is_iso_inserted(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether Nutanix Guest Tools ISO is inserted or not.
        """
        return pulumi.get(self, "is_iso_inserted")

    @is_iso_inserted.setter
    def is_iso_inserted(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_iso_inserted", value)

    @property
    @pulumi.getter(name="isReachable")
    def is_reachable(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the communication from VM to CVM is active or not.
        """
        return pulumi.get(self, "is_reachable")

    @is_reachable.setter
    def is_reachable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_reachable", value)

    @property
    @pulumi.getter(name="isVmMobilityDriversInstalled")
    def is_vm_mobility_drivers_installed(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the VM mobility drivers are installed on the VM or not.
        """
        return pulumi.get(self, "is_vm_mobility_drivers_installed")

    @is_vm_mobility_drivers_installed.setter
    def is_vm_mobility_drivers_installed(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_vm_mobility_drivers_installed", value)

    @property
    @pulumi.getter(name="isVssSnapshotCapable")
    def is_vss_snapshot_capable(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the VM is configured to take VSS snapshots through NGT or not.
        """
        return pulumi.get(self, "is_vss_snapshot_capable")

    @is_vss_snapshot_capable.setter
    def is_vss_snapshot_capable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_vss_snapshot_capable", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        Version of Nutanix Guest Tools installed on the VM.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)


class NgtInsertIsoV2(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capablities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ext_id: Optional[pulumi.Input[str]] = None,
                 is_config_only: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        """
        Provides Nutanix resource toInserts the Nutanix Guest Tools installation and configuration ISO into a virtual machine.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] capablities: The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        :param pulumi.Input[str] ext_id: uuid of the Virtual Machine.
        :param pulumi.Input[bool] is_config_only: Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NgtInsertIsoV2Args,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides Nutanix resource toInserts the Nutanix Guest Tools installation and configuration ISO into a virtual machine.

        :param str resource_name: The name of the resource.
        :param NgtInsertIsoV2Args args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NgtInsertIsoV2Args, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capablities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ext_id: Optional[pulumi.Input[str]] = None,
                 is_config_only: Optional[pulumi.Input[bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NgtInsertIsoV2Args.__new__(NgtInsertIsoV2Args)

            __props__.__dict__["capablities"] = capablities
            if ext_id is None and not opts.urn:
                raise TypeError("Missing required property 'ext_id'")
            __props__.__dict__["ext_id"] = ext_id
            __props__.__dict__["is_config_only"] = is_config_only
            __props__.__dict__["available_version"] = None
            __props__.__dict__["guest_os_version"] = None
            __props__.__dict__["is_enabled"] = None
            __props__.__dict__["is_installed"] = None
            __props__.__dict__["is_iso_inserted"] = None
            __props__.__dict__["is_reachable"] = None
            __props__.__dict__["is_vm_mobility_drivers_installed"] = None
            __props__.__dict__["is_vss_snapshot_capable"] = None
            __props__.__dict__["version"] = None
        super(NgtInsertIsoV2, __self__).__init__(
            'nutanix:index/ngtInsertIsoV2:NgtInsertIsoV2',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            available_version: Optional[pulumi.Input[str]] = None,
            capablities: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            ext_id: Optional[pulumi.Input[str]] = None,
            guest_os_version: Optional[pulumi.Input[str]] = None,
            is_config_only: Optional[pulumi.Input[bool]] = None,
            is_enabled: Optional[pulumi.Input[bool]] = None,
            is_installed: Optional[pulumi.Input[bool]] = None,
            is_iso_inserted: Optional[pulumi.Input[bool]] = None,
            is_reachable: Optional[pulumi.Input[bool]] = None,
            is_vm_mobility_drivers_installed: Optional[pulumi.Input[bool]] = None,
            is_vss_snapshot_capable: Optional[pulumi.Input[bool]] = None,
            version: Optional[pulumi.Input[str]] = None) -> 'NgtInsertIsoV2':
        """
        Get an existing NgtInsertIsoV2 resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] available_version: Version of Nutanix Guest Tools available on the cluster.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] capablities: The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        :param pulumi.Input[str] ext_id: uuid of the Virtual Machine.
        :param pulumi.Input[str] guest_os_version: Version of the operating system on the VM.
        :param pulumi.Input[bool] is_config_only: Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        :param pulumi.Input[bool] is_enabled: Indicates whether Nutanix Guest Tools is enabled or not.
        :param pulumi.Input[bool] is_installed: Indicates whether Nutanix Guest Tools is installed on the VM or not.
        :param pulumi.Input[bool] is_iso_inserted: Indicates whether Nutanix Guest Tools ISO is inserted or not.
        :param pulumi.Input[bool] is_reachable: Indicates whether the communication from VM to CVM is active or not.
        :param pulumi.Input[bool] is_vm_mobility_drivers_installed: Indicates whether the VM mobility drivers are installed on the VM or not.
        :param pulumi.Input[bool] is_vss_snapshot_capable: Indicates whether the VM is configured to take VSS snapshots through NGT or not.
        :param pulumi.Input[str] version: Version of Nutanix Guest Tools installed on the VM.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NgtInsertIsoV2State.__new__(_NgtInsertIsoV2State)

        __props__.__dict__["available_version"] = available_version
        __props__.__dict__["capablities"] = capablities
        __props__.__dict__["ext_id"] = ext_id
        __props__.__dict__["guest_os_version"] = guest_os_version
        __props__.__dict__["is_config_only"] = is_config_only
        __props__.__dict__["is_enabled"] = is_enabled
        __props__.__dict__["is_installed"] = is_installed
        __props__.__dict__["is_iso_inserted"] = is_iso_inserted
        __props__.__dict__["is_reachable"] = is_reachable
        __props__.__dict__["is_vm_mobility_drivers_installed"] = is_vm_mobility_drivers_installed
        __props__.__dict__["is_vss_snapshot_capable"] = is_vss_snapshot_capable
        __props__.__dict__["version"] = version
        return NgtInsertIsoV2(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="availableVersion")
    def available_version(self) -> pulumi.Output[str]:
        """
        Version of Nutanix Guest Tools available on the cluster.
        """
        return pulumi.get(self, "available_version")

    @property
    @pulumi.getter
    def capablities(self) -> pulumi.Output[Sequence[str]]:
        """
        The list of the application names that are enabled on the guest VM. [`SELF_SERVICE_RESTORE`, `VSS_SNAPSHOT`]
        """
        return pulumi.get(self, "capablities")

    @property
    @pulumi.getter(name="extId")
    def ext_id(self) -> pulumi.Output[str]:
        """
        uuid of the Virtual Machine.
        """
        return pulumi.get(self, "ext_id")

    @property
    @pulumi.getter(name="guestOsVersion")
    def guest_os_version(self) -> pulumi.Output[str]:
        """
        Version of the operating system on the VM.
        """
        return pulumi.get(self, "guest_os_version")

    @property
    @pulumi.getter(name="isConfigOnly")
    def is_config_only(self) -> pulumi.Output[bool]:
        """
        Indicates that the Nutanix Guest Tools are already installed on the guest VM, and the ISO is being inserted to update the configuration of these tools.
        """
        return pulumi.get(self, "is_config_only")

    @property
    @pulumi.getter(name="isEnabled")
    def is_enabled(self) -> pulumi.Output[bool]:
        """
        Indicates whether Nutanix Guest Tools is enabled or not.
        """
        return pulumi.get(self, "is_enabled")

    @property
    @pulumi.getter(name="isInstalled")
    def is_installed(self) -> pulumi.Output[bool]:
        """
        Indicates whether Nutanix Guest Tools is installed on the VM or not.
        """
        return pulumi.get(self, "is_installed")

    @property
    @pulumi.getter(name="isIsoInserted")
    def is_iso_inserted(self) -> pulumi.Output[bool]:
        """
        Indicates whether Nutanix Guest Tools ISO is inserted or not.
        """
        return pulumi.get(self, "is_iso_inserted")

    @property
    @pulumi.getter(name="isReachable")
    def is_reachable(self) -> pulumi.Output[bool]:
        """
        Indicates whether the communication from VM to CVM is active or not.
        """
        return pulumi.get(self, "is_reachable")

    @property
    @pulumi.getter(name="isVmMobilityDriversInstalled")
    def is_vm_mobility_drivers_installed(self) -> pulumi.Output[bool]:
        """
        Indicates whether the VM mobility drivers are installed on the VM or not.
        """
        return pulumi.get(self, "is_vm_mobility_drivers_installed")

    @property
    @pulumi.getter(name="isVssSnapshotCapable")
    def is_vss_snapshot_capable(self) -> pulumi.Output[bool]:
        """
        Indicates whether the VM is configured to take VSS snapshots through NGT or not.
        """
        return pulumi.get(self, "is_vss_snapshot_capable")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        Version of Nutanix Guest Tools installed on the VM.
        """
        return pulumi.get(self, "version")

